#include <bits/stdc++.h>

#define st first
#define nd second
#define pb push_back
#define rep(i, a, b) for(int i = (a); i < (b); ++i)
#define sci(x) int x; cin >> x;
#define scvi(v, n) vector<int> v(n); rep(i, 0, n) cin >> v[i];

using namespace std;

typedef long long ll;
typedef pair<int, int> ii;
typedef vector<int> vi;

map<char, int>num = {{'C' , 1},{'G' , 2},{'A' , 3},{'T' , 4}};

int deg[5][5];

int check(vi& v)
{
    int minn = 1<<20;
    for (int i=0; i<v.size(); i++)
    {
        minn = min(minn, deg[v[i]][v[(i+1)%v.size()]]);
    }
    if (minn > 0)
    {
        for (int i=0; i<v.size(); i++)
        {
            deg[v[i]][v[(i+1)%v.size()]] -= minn;
        }
    }
    return minn*(v.size() - 1);
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);

    string s,t;
    cin >> s >> t;
    int n = s.size();
    for (int i=0; i<n; ++i)
    {
        if (s[i] == t[i])
            continue;
        deg[num[s[i]]][num[t[i]]]++;
    }

    int ans = 0;
    for (int i=1; i<4; i++)
    {
        for (int j=i+1; j<=4; j++)
        {
            vi v = {i,j};
            ans += check(v);
        }
    }
    for (int i=1; i<4; i++)
    {
        for (int j=i+1; j<=4; j++)
        {
            for (int k = i+1; k <= 4; k++)
            {
                if (j == k)
                    continue;
                vi v = {i,j,k};
                ans += check(v);
            }
        }
    }

    int es = 0;
    for (int i=1; i<5; i++)
    {
        for (int j = 1; j<5; j++)
        {
            es += deg[i][j];
        }
    }

    ans += (es / 4)*3;
    cout << ans;

    return 0;
}